(provide 'stuff)

(defvar stuff-dot-channels-scm
  (let ((guix-url "https://git.savannah.gnu.org/git/guix.git")
        (nonguix-url "https://gitlab.com/nonguix/nonguix")
        (mine-url "https://gitlab.com/sys.arch.adam/deprecated"))
    `(list
       (channel
        (name 'guix)
        (url ,guix-url))
       (channel
        (name 'nonguix)
        (url ,nonguix-url))
       (channel
        (name 'mine)
        (url ,mine-url)
	(branch "main")))))

(defun stuff-init ()
  (interactive)
  (stuff-emacs-options-to-apply)
  (stuff-unix-misc)
  (stuff-generate-configs))

(defun stuff-emacs-options-to-apply ()
  
  (setq
   ;; for commits
   user-full-name "Adam Kandur"
   user-mail-address "rndd@tuta.io"

   comment-style 'extra-line
   dired-listing-switches "-alFh"
   inhibit-startup-screen t
   backup-directory-alist '(("." . "~/.emacs_saves")))

  (let ((guix-dir "~/p/guix"))
    (if (file-directory-p guix-dir)
        (progn
          (with-eval-after-load 'yasnippet
            (add-to-list 'yas-snippet-dirs
                         (concat guix-dir
                                 "/etc/snippets")))
          (load-file (concat guix-dir
                             "/etc/copyright.el")))))

  (menu-bar-mode 0)
  (tool-bar-mode 0)
  ;; needed for running emacs inside of emacs
  (scroll-bar-mode -1)

  (if (x-list-fonts "Terminus")
      (set-frame-font "Terminus 20" nil t))

  (load-theme 'vscode-dark-plus))

(defun stuff-generate-configs ()
  (stuff-generate-dot-emacs)
  (stuff-generate-dot-channels-scm))

(defun stuff-generate-dot-emacs ()
  (stuff-write-to-file "~/.emacs"
                       "(require 'stuff)\n(stuff-init)\n"))

(defun stuff-generate-dot-channels-scm ()
  (stuff-write-to-file "~/.channels.scm"
                       (concat "; Autogenerated by deprecated...\n"
                               (format "%S" stuff-dot-channels-scm))))

(defun stuff-unix-misc ()
  (shell-command "setxkbmap -option grp:alt_shift_toggle -layout 'us,ru'"))

(defun stuff-write-to-file (file string)
  (write-region string nil file))

(defun stuff-suspend ()
  (interactive)
  (shell-command "loginctl suspend && xlock"))


(global-set-key (kbd "C-x <f5>") 'stuff-suspend)
